        private void LoadFileUsingFieldTypesDataTable(String strFilenameWithPrefix, String strFilename)
        {
            DataTable csvData = new DataTable();
            csvData.TableName = "csvDataTable";
            String strFullFilename;
            Stopwatch swInterval;
            double duration;

            strFullFilename = strcFileDir + strFilenameWithPrefix + ".csv";
            lblFilename.Text = strFullFilename;

            swInterval = Stopwatch.StartNew();
            using (TextFieldParser csvReader = new TextFieldParser(strFullFilename))
            {
                csvReader.SetDelimiters(new string[] { "|" });
                csvReader.HasFieldsEnclosedInQuotes = false;
                string[] colFields = csvReader.ReadFields();

                // this code replaces the foreach loop in the string versions and tailors the 
                DataColumn dataColumn;
                dataColumn = new DataColumn("InstanceID", typeof(Byte));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("DateTimeValue", typeof(DateTime));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("database_id", typeof(Int16));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("object_id", typeof(Int32));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("index_id", typeof(Int32));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("partition_number", typeof(Int32));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("leaf_insert_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("leaf_delete_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("leaf_update_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("leaf_ghost_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("nonleaf_insert_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("nonleaf_delete_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("nonleaf_update_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("leaf_allocation_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("nonleaf_allocation_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("leaf_page_merge_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("nonleaf_page_merge_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("range_scan_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("singleton_lookup_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("forwarded_fetch_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("lob_fetch_in_pages", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("lob_fetch_in_bytes", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("lob_orphan_create_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("lob_orphan_insert_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("row_overflow_fetch_in_pages", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("row_overflow_fetch_in_bytes", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("column_value_push_off_row_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("column_value_pull_in_row_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("row_lock_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("row_lock_wait_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("row_lock_wait_in_ms", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("page_lock_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("page_lock_wait_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("page_lock_wait_in_ms", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("index_lock_promotion_attempt_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("index_lock_promotion_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("page_latch_wait_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("page_latch_wait_in_ms", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("page_io_latch_wait_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("page_io_latch_wait_in_ms", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("tree_page_latch_wait_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("tree_page_latch_wait_in_ms", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("tree_page_io_latch_wait_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("tree_page_io_latch_wait_in_ms", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("page_compression_attempt_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("page_compression_success_count", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);
                dataColumn = new DataColumn("hobt_id", typeof(Int64));
                dataColumn.AllowDBNull = true;
                csvData.Columns.Add(dataColumn);

                while (!csvReader.EndOfData)
                {
                    string[] fieldData = csvReader.ReadFields();

                    for (int i = 0; i < fieldData.Length; i++)
                    {
                        fieldData[i] = fieldData[i].Trim();
                    }
                    csvData.Rows.Add(fieldData);
                }
            }
            recordCount = csvData.Rows.Count;
            swInterval.Stop();
            duration = swInterval.Elapsed.TotalMilliseconds / 1000.0;
            logFile.WriteLine("{0},{1},{2},{3},{4}", strDesc, recordCount, "File", duration.ToString("#0.000"), recordCount / duration); //duration.ToString("HH:mm:ss.ffffff"));

            swInterval = Stopwatch.StartNew();

            SendTVP(csvData, recordCount);

            swInterval.Stop();
            duration = swInterval.Elapsed.TotalMilliseconds / 1000.0;
            logFile.WriteLine("{0},{1},{2},{3},{4}", strDesc, recordCount, "LTVP", duration.ToString("#0.000"), recordCount / duration); //duration.ToString("HH:mm:ss.ffffff"));
            csvData.Clear();
            csvData.Dispose();
        } // LoadFileUsingFieldTypesDataTable

        private void LoadFileUsingStringDataTable(String strFilenameWithPrefix, String strFilename)
        {
            DataTable csvData = new DataTable();
            csvData.TableName = "csvDataTable";
            String strFullFilename;
            Stopwatch swInterval;
            double duration;

            strFullFilename = strcFileDir + strFilenameWithPrefix + ".csv";
            lblFilename.Text = strFullFilename;

            swInterval = Stopwatch.StartNew();
            using (TextFieldParser csvReader = new TextFieldParser(strFullFilename))
            {
                csvReader.SetDelimiters(new string[] { "|" });
                csvReader.HasFieldsEnclosedInQuotes = false;
                string[] colFields = csvReader.ReadFields();

                foreach (string column in colFields)
                {
                    DataColumn dataColumn = new DataColumn(column);
                    dataColumn.AllowDBNull = true;
                    csvData.Columns.Add(dataColumn);
                }
                while (!csvReader.EndOfData)
                {
                    string[] fieldData = csvReader.ReadFields();

                    for (int i = 0; i < fieldData.Length; i++)
                    {
                        fieldData[i] = fieldData[i].Trim();
                    }
                    csvData.Rows.Add(fieldData);
                }
            }
            recordCount = csvData.Rows.Count;
            swInterval.Stop();
            duration = swInterval.Elapsed.TotalMilliseconds / 1000.0;
            logFile.WriteLine("{0},{1},{2},{3},{4}", strDesc, recordCount, "File", duration.ToString("#0.000"), recordCount / duration); //duration.ToString("HH:mm:ss.ffffff"));

            swInterval = Stopwatch.StartNew();

            SendTVP(csvData, recordCount);

            swInterval.Stop();
            duration = swInterval.Elapsed.TotalMilliseconds / 1000.0;
            logFile.WriteLine("{0},{1},{2},{3},{4}", strDesc, recordCount, "LTVP", duration.ToString("#0.000"), recordCount / duration); //duration.ToString("HH:mm:ss.ffffff"));
            csvData.Clear();
            csvData.Dispose();
        } // LoadFileUsingStringDataTable

        private void LoadFileUsingStringMaxLenDataTable(String strFilenameWithPrefix, String strFilename, int iMaxStringLen)
        {
            DataTable csvData = new DataTable();
            csvData.TableName = "csvDataTable";
            String strFullFilename;
            Stopwatch swInterval;
            double duration;

            strFullFilename = strcFileDir + strFilenameWithPrefix + ".csv";
            lblFilename.Text = strFullFilename;

            swInterval = Stopwatch.StartNew();
            using (TextFieldParser csvReader = new TextFieldParser(strFullFilename))
            {
                csvReader.SetDelimiters(new string[] { "|" });
                csvReader.HasFieldsEnclosedInQuotes = false;
                string[] colFields = csvReader.ReadFields();

                foreach (string column in colFields)
                {
                    DataColumn dataColumn = new DataColumn(column);
                    dataColumn.AllowDBNull = true;
                    dataColumn.MaxLength = iMaxStringLen;
                    csvData.Columns.Add(dataColumn);
                }
                while (!csvReader.EndOfData)
                {
                    string[] fieldData = csvReader.ReadFields();

                    for (int i = 0; i < fieldData.Length; i++)
                    {
                        fieldData[i] = fieldData[i].Trim();
                    }
                    csvData.Rows.Add(fieldData);
                }
            }
            recordCount = csvData.Rows.Count;
            swInterval.Stop();
            duration = swInterval.Elapsed.TotalMilliseconds / 1000.0;
            logFile.WriteLine("{0},{1},{2},{3},{4}", strDesc, recordCount, "File", duration.ToString("#0.000"), recordCount / duration); //duration.ToString("HH:mm:ss.ffffff"));

            swInterval = Stopwatch.StartNew();

            SendTVP(csvData, recordCount);

            swInterval.Stop();
            duration = swInterval.Elapsed.TotalMilliseconds / 1000.0;
            logFile.WriteLine("{0},{1},{2},{3},{4}", strDesc, recordCount, "LTVP", duration.ToString("#0.000"), recordCount / duration); //duration.ToString("HH:mm:ss.ffffff"));
            csvData.Clear();
            csvData.Dispose();
        } // LoadFileUsingStringMaxLenDataTable

        static int SendTVP(DataTable dt, int recordCount)
        {
            String strServer = "lenovo-jas"; //"Stx3-Desktopx64";
            String strDBName = "TestTVP";
            const String strcIntegratedSecurity = ";Integrated Security=SSPI";
            const String strcConnectionKeywords = ";Persist Security Info=True;Encrypt=False;Enlist=false;";
            String strConnectionKeywords = strcIntegratedSecurity + strcConnectionKeywords;
            const String strcPacketSize = "4096";
            int iTimeout = 1800;

            String strConnectionString =
                    "Server=" + strServer + strConnectionKeywords + "Initial Catalog=" + strDBName + ";Workstation ID=" + System.Windows.Forms.SystemInformation.ComputerName + "_TVPTest" + ";Packet Size=" + strcPacketSize + ";Pooling = false";

            using (SqlConnection conn = new SqlConnection(strConnectionString))
            {
                using (SqlCommand cmd = conn.CreateCommand())
                {
                    conn.Open();

                    cmd.Connection = conn;
                    cmd.CommandText = "truncate table SQLDynamicIndexOPStats";
                    cmd.CommandType = CommandType.Text;
                    cmd.CommandTimeout = 60; //seconds

                    cmd.ExecuteNonQuery();

                    cmd.CommandText = "ProcessAndInsertTVP";
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.CommandTimeout = iTimeout; //seconds

                    SqlParameter InxOp = new SqlParameter("@InxOp", dt);
                    InxOp.SqlDbType = SqlDbType.Structured;
                    cmd.Parameters.Add(InxOp);
                    try
                    {
                        cmd.ExecuteNonQuery();
                    }
                    catch (SqlException e)
                    {
                        throw;
                    }
                    finally
                    {
                        conn.Close();
                        conn.Dispose();
                    }
                    return 1;
                } // command
            } // connection
        } // SendTVP
